;##########################################################################
.386
.model flat, stdcall
option casemap:none
title WinMX Loader
;##########################################################################
include C:\masm32\include\windows.inc
include C:\masm32\include\kernel32.inc
include C:\masm32\include\user32.inc
includelib C:\masm32\lib\kernel32.lib
includelib C:\masm32\lib\user32.lib
;##########################################################################
szText MACRO Name, Text:VARARG
LOCAL lbl
	jmp	lbl
	Name	db	Text, 0
lbl:
ENDM
m2m MACRO M1, M2
	push	M2
	pop	M1
ENDM
m2mx MACRO M1, M2
	mov	eax, M2
	mov	M1, eax
ENDM
return MACRO RETVALUE
	mov	eax, RETVALUE
	ret
ENDM
iif MACRO condition, if_true, if_false, return
	.if condition
		mov	return, if_true
	.else
		mov	return, if_false
	.endif
ENDM
iifs MACRO condition, if_true, if_false, return
	mov	return, if_false
	.if condition
		mov	return, if_true
	.endif
ENDM
;##########################################################################
;##########################################################################
	WinMX_FileSize	equ		675840
	WinMX_CRC32	equ		0AF801196h
;##########################################################################
WndProc		PROTO	:DWORD,:DWORD,:DWORD,:DWORD
FileCRC		PROTO	:PTR BYTE
ErrorHandler	PROTO C	:DWORD,:DWORD,:DWORD,:DWORD
ExceptionFilter	PROTO	:DWORD
;##########################################################################
.const
	szAppTitle	db		"WinMX Loader", 0
	szMsgAbout	db		"WinMX Loader", 13, 10
			db		"Version 1.0 for WinMX version 3.1", 13, 10
			db		"Coded by comrade <comrade2k@hotmail.com>", 0
	szMsgOpenFail	db		"Unable to perform version check on WinMX.", 13, 10, "Continue?", 0
	szMsgWrongVer	db		"Wrong WinMX version! File size/CRC do not match!", 13, 10, "Continue?", 0
	szExecutable	db		"winmx.exe", 0
	szError		db		"Error", 0
	szErrorThread	db		"Error at %08Xh", 13, 10, "Registers:", 13, 10, "eax = %08Xh ebx = %08Xh ecx = %08Xh", 13, 10, "edx = %08Xh esp = %08Xh ebp = %08Xh", 13, 10, "esi = %08Xh edi = %08Xh", 13, 10, 13, 10, "Recovering...", 0
	szErrorFinal	db		"Error at %08Xh", 13, 10, "Quitting...", 0
	bNewBytes	db		00h
	include crc32.inc
;##########################################################################
.data
;##########################################################################
.data?
	szMessage	db		256 dup (?)
	dwBytesWritten	dd		?
	hFile		dd		?
	hFileMap	dd		?
	dwFile		dd		?
	dwFileSize	dd		?
	seh		dd		6 dup (?)

	data_start	equ		$
	pi		PROCESS_INFORMATION	<>
	sui		STARTUPINFO	<>
	data_size	equ		$ - data_start
;##########################################################################
.code
start:	invoke	SetUnhandledExceptionFilter, ADDR ExceptionFilter
	assume	fs:nothing
	push	OFFSET ErrorHandler
	push	FS:[0]
	mov	[seh], esp
	mov	[seh+4], ebp
	mov	[seh+8], ebx
	mov	[seh+12], esi
	mov	[seh+16], edi
	mov	[seh+20], OFFSET @@safe
	mov	FS:[0], esp
	; critical code

	invoke	FileCRC, ADDR szExecutable
	test	ecx, ecx
	push	eax
	.if zero?
		invoke	MessageBox, 0, ADDR szMsgOpenFail, ADDR szAppTitle, MB_YESNO OR MB_ICONQUESTION OR MB_APPLMODAL
		cmp	eax, IDYES
		je	@@crcc
		pop	eax
		jmp	@@safe
	.endif
@@crcc:	pop	eax
	cmp	[dwFileSize], WinMX_FileSize
	jne	@@mism
	cmp	eax, WinMX_CRC32
	je	@@ok
@@mism:	invoke	MessageBox, 0, ADDR szMsgWrongVer, ADDR szAppTitle, MB_YESNO OR MB_ICONQUESTION OR MB_APPLMODAL
	cmp	eax, IDNO
	je	@@safe
@@ok:	push	edi
	xor	eax, eax
	mov	ecx, data_size shr 2
	mov	edi, data_start
	rep	stosd
	IF data_size AND 3
		mov	edi, data_start
		mov	ecx, data_size and 3
		rep	stosb
	ENDIF
	pop	edi
	mov	[sui.cb], sizeof STARTUPINFO
	mov	[sui.dwFlags], STARTF_USESHOWWINDOW
	mov	[sui.wShowWindow], SW_SHOW
	invoke	CreateProcess, ADDR szExecutable, eax, eax, eax, eax, NORMAL_PRIORITY_CLASS, eax, eax, ADDR sui, ADDR pi
	invoke	WaitForInputIdle, [pi.hProcess], INFINITE
	invoke	WriteProcessMemory, [pi.hProcess], 00484DAAh, ADDR bNewBytes, sizeof bNewBytes, ADDR dwBytesWritten
	invoke	WriteProcessMemory, [pi.hProcess], 004946BFh, ADDR bNewBytes, sizeof bNewBytes, ADDR dwBytesWritten
@@safe:	pop	FS:[0]
	add	esp, 4
	invoke	ExitProcess, eax
;##########################################################################
ErrorHandler proc C lpExcept:DWORD, lpFrame:DWORD, lpContext:DWORD, lpDispatch:DWORD
	mov	eax, [lpExcept]
	mov	ecx, [lpContext]
	invoke	wsprintf, ADDR szMessage, ADDR szErrorThread, [eax][EXCEPTION_RECORD.ExceptionAddress], [ecx][CONTEXT.regEax], [ecx][CONTEXT.regEbx], [ecx][CONTEXT.regEcx], [ecx][CONTEXT.regEdx], [ecx][CONTEXT.regEsp], [ecx][CONTEXT.regEbp], [ecx][CONTEXT.regEsi], [ecx][CONTEXT.regEdi]
	invoke	MessageBox, 0, ADDR szMessage, ADDR szError, MB_OK OR MB_ICONHAND OR MB_APPLMODAL

	mov	eax, [lpContext]
	m2m	[eax][CONTEXT.regEsp], [seh]
	m2m	[eax][CONTEXT.regEbp], [seh+4]
	m2m	[eax][CONTEXT.regEbx], [seh+8]
	m2m	[eax][CONTEXT.regEsi], [seh+12]
	m2m	[eax][CONTEXT.regEdi], [seh+16]
	m2m	[eax][CONTEXT.regEip], [seh+20]

	xor	eax, eax	; continue execution
	ret
ErrorHandler endp
;##########################################################################
ExceptionFilter proc lpExcept:DWORD
	mov	eax, [lpExcept]
	invoke	wsprintf, ADDR szMessage, ADDR szErrorFinal, [eax][EXCEPTION_RECORD.ExceptionAddress]
	invoke	MessageBox, 0, ADDR szMessage, ADDR szError, MB_OK OR MB_ICONHAND OR MB_APPLMODAL
	invoke	ExitProcess, 0
	xor	eax, eax
	inc	eax		; EXCEPTION_EXECUTE_HANDLER
	ret
ExceptionFilter endp
;##########################################################################
FileCRC proc pszFileName:PTR BYTE
	xor	eax, eax
	invoke	CreateFile, [pszFileName], GENERIC_READ, FILE_SHARE_READ, eax, OPEN_EXISTING, eax, eax
	xor	ecx, ecx
	cmp	eax, INVALID_HANDLE_VALUE
	mov	[hFile], eax
	je	@@quit
	invoke	GetFileSize, eax, 0
	test	eax, eax
	mov	[dwFileSize], eax
	jz	@@quit
	xor	ecx, ecx
	invoke	CreateFileMapping, [hFile], ecx, PAGE_READONLY, ecx, ecx, ecx
	xor	ecx, ecx
	test	eax, eax
	mov	[hFileMap], eax
	jz	@@quit
	invoke	MapViewOfFile, eax, FILE_MAP_READ, ecx, ecx, ecx
	xor	ecx, ecx
	test	eax, eax
	mov	[dwFile], eax
	jz	@@quit
	push	esi
	mov	esi, eax
	mov	ecx, [dwFileSize]
	or	eax, 0FFFFFFFFh
@@redo:	xor	edx, edx
	xor	al, [esi]
	mov	dl, al
	shr	eax, 8
	xor	eax, dword ptr [CRC32+edx*4]
	inc	esi
	loopd	@@redo
	pop	esi
	not	eax
	inc	ecx
	push	eax
@@quit:	push	ecx
	invoke	UnmapViewOfFile, [dwFile]
	invoke	CloseHandle, [hFileMap]
	invoke	CloseHandle, [hFile]
	pop	ecx
	pop	eax
	ret
FileCRC endp
;##########################################################################
;##########################################################################
;##########################################################################
end start